/**
 * delight.Camera
 * 
 * License: GPL
 * Author: Pyo Taesu
 */
module delight.Camera;
private import delight.Math;
private import delight.Scene;
private import delight.Ray;
private import tango.io.Stdout;
private import tango.core.Exception;

class Camera : SceneObjectBase
{
	float fov;
	
	void initCamera(Vector3 pos, Vector3 target, Vector3 up, float fov)
	{
		auto uz = normalize(pos - target);
		auto ux = cross(up, uz);
		
		if (length(ux) < 0.00001f)
		{
			throw new IllegalArgumentException("Camera.initCamera : failed!");
		}
		
		ux = normalize(ux);
		auto uy = cross(uz, ux);

		worldTransform = Matrix34(ux, uy, uz, pos);
		this.fov = fov;
	}
	
	Ray pickRay(Vector3 localRayDir)
	{
		Ray ray;
		ray.origin = position;
		ray.direction = normalize(rotate(worldTransform, localRayDir));
		
		return ray;
	}
	
	// TODO: implement...
}
