/**
 * delight.Util
 * 
 * License: GPL
 * Author: Pyo Taesu
 */
module delight.Util;

bool startsWith(T)(T a, T b)
{
	return a[0..b.length] == b;	
}

void swap(T)(ref T a, ref T b)
{
	T c = a;
	a = b;
	b = c;
}

struct Range(T)
{
	T a, b;
	static Range!(T) opCall(T a, T b)
	{
		Range!(T) r = {a , b};
		return r;
	}
	
	int opApply(int delegate(ref T) dg)
	{
		int r = 0;
		
		for(T i = a ; i < b ; ++i)
		{
			r = dg(i);
			if (r) break;
		}
		return r;
	}
}

Range!(T) range(T)(T a, T b)
{
	return Range!(T)(a, b);
}

Range!(T) range(T)(T b)
{
	return Range!(T)(0, b);
}
