/**
 * delight_run
 * 
 * License: GPL
 * Author: Pyo Taesu
 */
module delight_run;

import tango.io.Stdout;
import tango.time.Clock;
import delight_bn;
import delight.Scene;
import delight.SceneLoader;
import delight.Image;
import delight.Renderer;

int main(char[][] args)
{
	auto time = Clock.now;
	
	Stdout("Delight (build ")(delight_bn.buildnumber)(")").newline.flush;

	{
		auto scene = new Scene;
		auto sceneLoader = new SceneLoader(scene);
		sceneLoader.loadFromXml("scene.xml");
		
		auto image = new Image;
		auto renderer = new Renderer(scene, image);
		
		renderer.render();
		
		image.saveAsBmp("rendered_image.bmp");
	}
	
	auto elapsed = Clock.now - time;
	Stdout("Elapsed: ")(elapsed.millis).newline;
	
	return 0;
}
